package com.tsi.comm.server.process.logging;

import com.tsi.app.common.app.AppUtils;
import com.tsi.comm.server.config.TsiCvimServerConfig;
import com.tsi.comm.server.process.AbstractTsiCvimProcess;
import com.tsi.comm.server.process.AbstractTsiCvimWorker;
import com.tsi.comm.server.protocol.AbstractTsiPacket;
import com.tsi.comm.server.repository.TsiNodeManager;
import lombok.Getter;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.slf4j.MDC;
import org.springframework.stereotype.Service;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.ThreadFactory;
import java.util.concurrent.TimeUnit;

@Slf4j
@Getter
@RequiredArgsConstructor
@Service
public class TsiCvimLoggingProcess extends AbstractTsiCvimProcess {

    private final TsiNodeManager nodeManager;

    private ExecutorService executor = null;
    private int qSize;

    public void start() {
        ThreadGroup workerGroup = new ThreadGroup("loggingProcess");
        TsiCvimServerConfig tsiCvimServerConfig = (TsiCvimServerConfig) AppUtils.getBean(TsiCvimServerConfig.class);

        this.workers = tsiCvimServerConfig.getLoggingWorkers();
        this.qSize = this.nodeManager.size();
        if (this.workers == 1) {
            this.qSize *= 2;
        }

        this.executor = Executors.newFixedThreadPool(this.workers, new ThreadFactory() {
            private int count = 0;
            public Thread newThread(Runnable r) {
                Thread t = new Thread(workerGroup, r);
                t.setName(String.format("logWorker-%02d.%02d", workers, ++count));
                t.setDaemon(true);
                return t;
            }
        });

        for (int ii = 0; ii < this.workers; ii++) {
            TsiCvimLoggingWorker loggingWorker = new TsiCvimLoggingWorker(ii, this.qSize);
            this.workerList.add(loggingWorker);
            this.executor.submit(loggingWorker); // 여기서 실행됨!
        }

//        for (int ii = 0; ii < this.workers; ii++) {
//            TsiCvimLoggingWorker loggingWorker = new TsiCvimLoggingWorker(ii, qSize);
//            this.workerList.add(loggingWorker);
//            Thread worker = new Thread(workerGroup, loggingWorker);
//            worker.setName(String.format("logWorker-%02d.%02d", this.workers, ii+1));
//            worker.setDaemon(true);
//            this.threadList.add(worker);
//        }
//        for (Thread worker : this.threadList) {
//            worker.start();
//        }
    }

    public boolean add(Object object, int idx) {
        boolean offer = false;
        AbstractTsiPacket packet = (AbstractTsiPacket)object;
        try {
//            idx = idx % this.workers;
            idx = Math.abs(idx % this.workers);
            offer = this.workerList.get(idx).add(packet);
        }
        catch (Exception e) {
            MDC.put("id", Long.toString(packet.getNodeId()));
            log.error("LoggingProcess: QUEUE_DATA.add: Exception: {}, {}", packet.getNodeId(), e.getMessage());
            MDC.clear();
        }
        return offer;
    }

    public void stop() {
        log.info("LoggingProcess Stopping...");
        this.executor.shutdown();
        try {
            if (!this.executor.awaitTermination(3, TimeUnit.SECONDS)) {
                this.executor.shutdownNow(); // 실행 중인 작업도 중단 시도
            }
        } catch (InterruptedException e) {
            this.executor.shutdownNow();
            Thread.currentThread().interrupt(); // 현재 스레드도 중단
        }
        log.info("LoggingProcess Stopped...");
    }

    public void report() {
        for (AbstractTsiCvimWorker worker : this.workerList) {
            worker.report();
        }
    }
}
